﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using WebTemplateAPI.Modules;

#nullable disable

namespace WebTemplateAPI.Data.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    [Migration("20221115164250_Identity")]
    partial class Identity
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "6.0.10")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRole", b =>
                {
                    b.Property<string>("Id")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken()
                        .HasColumnType("longtext");

                    b.Property<string>("Name")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<string>("NormalizedName")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.HasKey("Id");

                    b.HasIndex("NormalizedName")
                        .IsUnique()
                        .HasDatabaseName("RoleNameIndex");

                    b.ToTable("AspNetRoles", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("ClaimType")
                        .HasColumnType("longtext");

                    b.Property<string>("ClaimValue")
                        .HasColumnType("longtext");

                    b.Property<string>("RoleId")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.HasKey("Id");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetRoleClaims", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("int");

                    b.Property<string>("ClaimType")
                        .HasColumnType("longtext");

                    b.Property<string>("ClaimValue")
                        .HasColumnType("longtext");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserClaims", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.Property<string>("LoginProvider")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("ProviderKey")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("ProviderDisplayName")
                        .HasColumnType("longtext");

                    b.Property<string>("UserId")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.HasKey("LoginProvider", "ProviderKey");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserLogins", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.Property<string>("UserId")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("RoleId")
                        .HasColumnType("varchar(95)");

                    b.HasKey("UserId", "RoleId");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetUserRoles", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.Property<string>("UserId")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("LoginProvider")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("Name")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("Value")
                        .HasColumnType("longtext");

                    b.HasKey("UserId", "LoginProvider", "Name");

                    b.ToTable("AspNetUserTokens", (string)null);
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Comments", b =>
                {
                    b.Property<decimal>("comm_id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("decimal(65,30)");

                    b.Property<decimal?>("Commentscomm_id")
                        .HasColumnType("decimal(65,30)");

                    b.Property<string>("author")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.Property<string>("content")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<DateTime>("createdAt")
                        .HasColumnType("datetime");

                    b.Property<int>("parent_id")
                        .HasColumnType("int");

                    b.Property<decimal>("posts_id")
                        .HasColumnType("decimal(65,30)");

                    b.Property<DateTime>("updatedAt")
                        .HasColumnType("datetime");

                    b.HasKey("comm_id");

                    b.HasIndex("Commentscomm_id");

                    b.HasIndex("author");

                    b.HasIndex("comm_id");

                    b.HasIndex("content");

                    b.HasIndex("createdAt");

                    b.HasIndex("parent_id");

                    b.HasIndex("posts_id");

                    b.HasIndex("updatedAt");

                    b.ToTable("comments");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Posts", b =>
                {
                    b.Property<decimal>("posts_id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("decimal(65,30)");

                    b.Property<string>("author")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.Property<bool>("banned")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("content")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.Property<DateTime>("created_at")
                        .HasColumnType("datetime");

                    b.Property<DateTime>("updated_at")
                        .HasColumnType("datetime");

                    b.HasKey("posts_id");

                    b.HasIndex("author");

                    b.HasIndex("banned");

                    b.HasIndex("content");

                    b.HasIndex("created_at");

                    b.HasIndex("posts_id");

                    b.HasIndex("updated_at");

                    b.ToTable("posts");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Reports", b =>
                {
                    b.Property<decimal>("reports_id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("decimal(65,30)");

                    b.Property<string>("UserId")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("reportedby")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.Property<decimal>("reportedpost")
                        .HasColumnType("decimal(65,30)");

                    b.Property<string>("reporttext")
                        .IsRequired()
                        .HasColumnType("longtext");

                    b.HasKey("reports_id");

                    b.HasIndex("UserId");

                    b.HasIndex("reportedby");

                    b.HasIndex("reportedpost");

                    b.HasIndex("reports_id");

                    b.HasIndex("reporttext");

                    b.ToTable("reports");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.ReportsHandled", b =>
                {
                    b.Property<decimal>("handled_id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("decimal(65,30)");

                    b.Property<string>("UserId")
                        .HasColumnType("varchar(95)");

                    b.Property<string>("handledby")
                        .IsRequired()
                        .HasColumnType("varchar(95)");

                    b.Property<string>("handledstat")
                        .IsRequired()
                        .HasColumnType("varchar(20)");

                    b.Property<decimal>("reports_id")
                        .HasColumnType("decimal(65,30)");

                    b.HasKey("handled_id");

                    b.HasIndex("UserId");

                    b.HasIndex("handled_id");

                    b.HasIndex("handledby");

                    b.HasIndex("handledstat");

                    b.HasIndex("reports_id");

                    b.ToTable("reports_handled");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Users", b =>
                {
                    b.Property<string>("Id")
                        .HasColumnType("varchar(95)");

                    b.Property<int>("AccessFailedCount")
                        .HasColumnType("int");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken()
                        .HasColumnType("longtext");

                    b.Property<string>("Email")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<bool>("EmailConfirmed")
                        .HasColumnType("tinyint(1)");

                    b.Property<bool>("LockoutEnabled")
                        .HasColumnType("tinyint(1)");

                    b.Property<DateTimeOffset?>("LockoutEnd")
                        .HasColumnType("datetime");

                    b.Property<string>("NormalizedEmail")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<string>("NormalizedUserName")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.Property<string>("PasswordHash")
                        .HasColumnType("longtext");

                    b.Property<string>("PhoneNumber")
                        .HasColumnType("longtext");

                    b.Property<bool>("PhoneNumberConfirmed")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("SecurityStamp")
                        .HasColumnType("longtext");

                    b.Property<bool>("TwoFactorEnabled")
                        .HasColumnType("tinyint(1)");

                    b.Property<string>("UserName")
                        .HasMaxLength(256)
                        .HasColumnType("varchar(256)");

                    b.HasKey("Id");

                    b.HasIndex("NormalizedEmail")
                        .HasDatabaseName("EmailIndex");

                    b.HasIndex("NormalizedUserName")
                        .IsUnique()
                        .HasDatabaseName("UserNameIndex");

                    b.ToTable("AspNetUsers", (string)null);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole", null)
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole", null)
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("WebTemplateAPI.Modules.Data.Users", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", null)
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Comments", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Comments", null)
                        .WithMany("Parents")
                        .HasForeignKey("Commentscomm_id");

                    b.HasOne("WebTemplateAPI.Modules.Data.Users", "Users")
                        .WithMany("Comments")
                        .HasForeignKey("author")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("WebTemplateAPI.Modules.Data.Posts", "Posts")
                        .WithMany("Comments")
                        .HasForeignKey("posts_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Posts");

                    b.Navigation("Users");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Posts", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", "Users")
                        .WithMany("Posts")
                        .HasForeignKey("author")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Users");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Reports", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", "User")
                        .WithMany("Reports")
                        .HasForeignKey("UserId");

                    b.HasOne("WebTemplateAPI.Modules.Data.Posts", "Posts")
                        .WithMany("Reports")
                        .HasForeignKey("reportedpost")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Posts");

                    b.Navigation("User");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.ReportsHandled", b =>
                {
                    b.HasOne("WebTemplateAPI.Modules.Data.Users", "User")
                        .WithMany("ReportsHandleds")
                        .HasForeignKey("UserId");

                    b.HasOne("WebTemplateAPI.Modules.Data.Reports", "Reports")
                        .WithMany("ReportsHandleds")
                        .HasForeignKey("reports_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Reports");

                    b.Navigation("User");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Comments", b =>
                {
                    b.Navigation("Parents");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Posts", b =>
                {
                    b.Navigation("Comments");

                    b.Navigation("Reports");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Reports", b =>
                {
                    b.Navigation("ReportsHandleds");
                });

            modelBuilder.Entity("WebTemplateAPI.Modules.Data.Users", b =>
                {
                    b.Navigation("Comments");

                    b.Navigation("Posts");

                    b.Navigation("Reports");

                    b.Navigation("ReportsHandleds");
                });
#pragma warning restore 612, 618
        }
    }
}
